<template>
  <div class="hello">
    <!-- <input type="text" v-model="msg">
    <button @click="sendSon">传给儿子</button> -->
    <!-- <h2>父组件</h2>
    <h3>子组件传来的{{msg2}}</h3>
    <son :msg="msg" @mess="sendfather"></son>
    <one />
    <two /> -->
    <div class="box" v-for="(item,index) in goodsList" :key="index">
      <h3>商品名字{{item.name}}</h3>
      <h3>商品价格{{item.price}}</h3>
      <div class="btn">
        <button @click="sortNum(index)">-</button>
        <h4>{{item.num}}</h4>
        <button @click="upNum(index)">+</button>
      </div>
      <div class="num">
        合计{{totalNum}}
        总价{{totalPrice}}
      </div>
    </div>
    <watch />
  </div>
</template>

<script>
import son from './son';
import one from './one';
import two from './two';
import watch from './watch';
import { mapState } from 'vuex';

export default {
  name: 'HelloWorld',
  components: {
    son, one, two, watch,
  },
  data() {
    return {
      msg: '父亲',
      msg2: '',
    };
  },
  mounted() {
    console.log(this.$store.getters.goodsObj);
    console.log(this.$store.getters.goodsById('2'));
  },
  computed: {
    // goods () {
    //   return this.$store.state.goods
    // }
    // ...mapState(['goods'])
    // 换名
    ...mapState({
      goodsList: state => state.car.goods,
      totalNum: state => state.car.totalNum,
      totalPrice: state => state.car.totalPrice,
    }),
  },
  methods: {
    sendfather(val) {
      if (val) {
        this.msg2 = val;
      } else {
        alert('没有内容');
      }
    },
    upNum(index) {
      console.log(index);
      // this.$store.commit('add', index)

      // this.$store.commit({
      //   type: 'ADD',
      //   index
      // })

      this.$store.dispatch('increment', { index });
    },
    sortNum() {

    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
* {
  display: flex;
}
.box{
  display: flex;
  flex-direction: column;
  width: 200px;
  height: 200px;
  border: 1px solid red;
}
.btn {
  display: flex;
  flex-direction: row;
  justify-content: space-around;
  height: 20px;
  align-items: center;
}
.num {
  margin: 20px auto;
}
/* button {
  width: 50px;
  height: 50px;
} */
</style>
